[21.04 FEAT] zKVM: Add support for virtio-fs

Bug #1887924 reported by bugproxy
14
This bug affects 1 person
Affects Status Importance Assigned to Milestone
Ubuntu on IBM z Systems
Fix Released
High
Skipper Bug Screeners
qemu (Ubuntu)
Fix Released
Undecided
Skipper Bug Screeners

Bug Description

Virtio-fs provides the capability to share a host filesystem with a guest.
It is required by new container workloads where it is about to supersede plan9fs.

Currently, virtio-fs is not supported on IBM Z.

Obvious missing pre-requisites are the capability to provide a shared memory backing in conjunction with a NUMA topology specification.
Once the NUMA support is in place, further development may be required.

bugproxy (bugproxy)
tags: added: architecture-s39064 bugnameltc-186786 severity-high targetmilestone-inin2010
Changed in ubuntu:
assignee: nobody → Skipper Bug Screeners (skipper-screen-team)
affects: ubuntu → linux (Ubuntu)
Revision history for this message
Frank Heimes (fheimes) wrote :

Changing to Incomplete until code got upstream released (and potential backport was made available, in case cherry-pick is not possible).
Please notice that this can be very tight in time for groovy, since you mentioned that the code will land in "kernel >= 5.9".

Changed in ubuntu-z-systems:
assignee: nobody → Skipper Bug Screeners (skipper-screen-team)
importance: Undecided → High
status: New → Incomplete
Revision history for this message
bugproxy (bugproxy) wrote : Comment bridged from LTC Bugzilla

------- Comment From <email address hidden> 2020-08-24 08:38 EDT-------
The kernel contribution is already available with Ubuntu 20.04.
I missed the qemu package information here.
Package: qemu >5.1

Currently we are working on getting this upstream, its a high important item for exploiting offerings.

Here I would assume a feature freeze exception, just as a heads up....!

Frank Heimes (fheimes)
tags: added: qemu-20.10
Revision history for this message
Frank Heimes (fheimes) wrote : Re: [20.10 FEAT] zKVM: Add support for virtio-fs

It looks to me that this could also just become a 20.10 post-GA SRU, since you really want it at the end in 20.04 rather than in 20.10, right? (20.10 just to start with the current development release)
When do you plan to exploit this?

Revision history for this message
Frank Heimes (fheimes) wrote :

And just a quick clarification between the statement in the bug description:
"Target kernel >= 5.9 , backport required"
and comment #2:
"The kernel contribution is already available with Ubuntu 20.04."

Is the kernel part already in 20.04, since 20.04 has kernel 5.4?
Did we already SRUed of the patches back to focal? But in this case it can't be 5.9 ...

Revision history for this message
bugproxy (bugproxy) wrote : Comment bridged from LTC Bugzilla

------- Comment From <email address hidden> 2020-08-25 02:04 EDT-------
The kernel part is done. Now a qemu update need to be applied, as I mentioned in my previous comment..

Revision history for this message
Frank Heimes (fheimes) wrote : Re: [20.10 FEAT] zKVM: Add support for virtio-fs

Okay, so the line 'Target kernel >= 5.9 , backport required' is obsolete and I'll remove it and will also remove the kernel as affected package.

description: updated
no longer affects: linux (Ubuntu)
Changed in qemu (Ubuntu):
assignee: nobody → Canonical Server Team (canonical-server)
Revision history for this message
bugproxy (bugproxy) wrote : Comment bridged from LTC Bugzilla

------- Comment From <email address hidden> 2020-09-02 02:41 EDT-------
Patches are now available !
https://lists.gnu.org/archive/html/qemu-devel/2020-09/msg00428.html

Can someone from Canonical give it a try,
and verify x86 vhost-user-scsi is still working with the patches applied?

Revision history for this message
Frank Heimes (fheimes) wrote : Re: [20.10 FEAT] zKVM: Add support for virtio-fs

Even if the changes are not significant, they are not yet upstream accepted (which is a requirement for picking them up) and with that they are not yet reviewed nor widely tested.
Hence the suggestion is (especially now after groovy feature freeze: https://lists.ubuntu.com/archives/ubuntu-devel-announce/2020-August/001279.html) to properly bring the modifications upstream and get it tested and stabilized, so that it's ready for the inclusion into 21.04.
(Please notice that virtio-fs was even for amd64 just recently added.)
A FFe (https://wiki.ubuntu.com/FeatureFreeze) would require special approval and a strong rationale with business case.
If the main reason is early testing, I think it's best to create PPA with a patched qemu version.

Revision history for this message
bugproxy (bugproxy) wrote : Comment bridged from LTC Bugzilla

------- Comment From <email address hidden> 2020-09-21 08:17 EDT-------
The rationale is that virtio-fs is the method of choice to access files in the host in a secure and performant way. Specifically, Kata Containers has virtio-fs as a prerequisite. We will need that feature in the LTS release.

------- Comment From <email address hidden> 2020-09-21 08:19 EDT-------
I forgot to add, the patches have been added to Stefan Hajnoczi's (virtiofs co-maintainer) block branch at https://github.com/stefanha/qemu/commits/block.

summary: - [20.10 FEAT] zKVM: Add support for virtio-fs
+ [21.04 FEAT] zKVM: Add support for virtio-fs
Revision history for this message
bugproxy (bugproxy) wrote :

------- Comment From <email address hidden> 2020-09-22 09:01 EDT-------
Feature request need to be moved to 21.04, will not make it in time for 20.10.

And once the the upstream acceptance is given, it can be added to the qemu release of 21.04 and an SRU for focal groovy and focal(mandatory) will be requested

tags: added: targetmilestone-inin2104
removed: targetmilestone-inin2010
Revision history for this message
Frank Heimes (fheimes) wrote :

Once the development of the 'H-release' is open, we can pick this up again and may it for a consider potential SRU ...

Changed in qemu (Ubuntu):
status: New → Incomplete
assignee: Canonical Server Team (canonical-server) → Skipper Bug Screeners (skipper-screen-team)
Frank Heimes (fheimes)
tags: added: qemu-21.04
removed: qemu-20.10
Revision history for this message
Christian Ehrhardt  (paelzer) wrote :

Thanks - This is upstream and will be in qemu v5.2 and therefore revisited when we merge that (December/January).

Revision history for this message
Frank Heimes (fheimes) wrote :

Since qemu 5.2 recently landed in hirsute:
qemu | 1:5.2+dfsg-3ubuntu1 | hirsute
I'm closing this ticket as Fix Released.

Changed in qemu (Ubuntu):
status: Incomplete → Fix Released
Changed in ubuntu-z-systems:
status: Incomplete → Fix Released
Revision history for this message
bugproxy (bugproxy) wrote :

------- Comment From <email address hidden> 2021-02-04 07:02 EDT-------
Feature will be provided with qemu 5.2

Revision history for this message
bugproxy (bugproxy) wrote :

------- Comment From <email address hidden> 2021-02-04 07:16 EDT-------
IBM Bugzilla status->closed, Fix released with hirsuite

Frank Heimes (fheimes)
information type: Private → Public
To post a comment you must log in.
This report contains Public information  
Everyone can see this information.

Other bug subscribers